/******************************************************************************/
/* ST_ERROR.H								      */
/******************************************************************************/

#ifndef	__HEADER_ST_ERROR
#define	__HEADER_ST_ERROR	__HEADER_ST_ERROR

/* -------------------------------------------------------------------------- */

/* error and message macros used through out */

#define	E_MALL			-1	/* Memory allocation failure */
#define	E_OPENF			-2	/* Open Disk file failure */
#define	E_READF			-3	/* Read Disk file failure */
#define	E_WRITF			-4	/* Write Disk file failure */

#define	E_SCRAPINIT		-5

#define	E_SAVEDOCU		-6	/* Save Docu at wind close ? */
#define	E_FILEXIST		-7	/* File overwrite ? */
#define	E_WINDLIM		-8	/* No more windows */

#define	E_FSI			-9	/* File Selector Box failure */
#define	E_INVALIDFNAME		-10	/* Invalid file name  */
#define	E_ACCESSF		-11	/* Disk file access failure */

#define	E_FATALSCRAP		-12
#define	E_INVALIDPARM		-13

#define	E_CDROMTITLE		-14	/* must enter CDROM title */

#define	E_NOSESSION		-15	/* session does not exist */
#define	E_NOTRACK		-16	/* track does not exist */

#define	E_UNDOERR		-17	/* error while saving undo */

#define	E_STRNOTFOUND		-18	/* string not found */

#define	E_LOG_OPEN		-20	/* open log file */
#define	E_LOG_WRITE		-21	/* write to log file */

#define	E_I2S_NOLODFILE		-22	/* I2S.LOD can not be found */
#define	E_I2S_SOUNDLOCKED	-23	/* sound system is locked */
#define	E_I2S_NOMEMORY		-24	/* not enougn memory for I2S.LOD */
#define	E_I2S_LOADERROR		-25	/* error during loading I2S.LOD */

/* -------------------------------------------------------------------------- */

/* free strings used in credit box */

#define	DIAL_INFO_AUTHOR		1
#define	DIAL_INFO_LOAD_RESOURCE		2
#define	DIAL_INFO_LOAD_FONTS		3
#define	DIAL_INFO_INITIALISING		4
#define	DIAL_INFO_OKBUTTON		5

/* miscellaneous strings used for menu strings, etc. */

#define	FR_UNTITLED			11
#define	FR_SAVED			12
#define	FR_NOTSAVED			13

/* free strings used in file selector box */

#define	FSEL_LOGFILENAME		20

#define	FSEL_SAVE_CDROM			21
#define	FSEL_LOAD_CDROM			22

#define	FSEL_SAVE_TOC			23
#define	FSEL_LOAD_TOC			24

#define	FSEL_ITEMFILENAME		25

/* different strings used in display */

#define	FR_SESSION			82
#define	FR_TRACK			83

#define	FR_INFORMATION			84

#define	FR_LASTLINE			86

#define	FR_FILENAME			87
#define	FR_ABSQTIMESUBCODE		88
#define	FR_RELQTIMESUBCODE		89

/* header titles for display */

#define	FR_SIZE				90
#define	FR_STARTTIME			91
#define	FR_ENDTIME			92
#define	FR_COMMENT			93

/* different strings used in emulation log file */

#define	FR_INIT_EMULATOR		101
#define	FR_CHECK_CDROM			102
#define	FR_CHECK_SESSION		103
#define	FR_CHECK_TRACK			104
#define	FR_CHECK_FILES_NOT		105
#define	FR_CHECK_FILES_YES		106
#define	FR_UPDATE_QTIME			107
#define	FR_INIT_I2SBUS			108
#define	FR_INIT_DSABUS			109
#define	FR_INIT_PARAMS			110
#define	FR_QUIT_EMULATION		111

/* different command strings to servo processor */

#define	FR_RESERVED			201
#define	FR_UNDEFINED			202
#define	FR_USERDEFINED			203

#define	FR_PLAYTITLE			204
#define	FR_STOP				205
#define	FR_READTOC			206
#define	FR_PAUSE			207
#define	FR_UNPAUSE			208
#define	FR_GETTITLELEN			209
#define	FR_OPENTRAY			210
#define	FR_CLOSETRAY			211
#define	FR_GETCOMPTIME			212
#define	FR_GOTOABSMIN			213
#define	FR_GOTOABSSEC			214
#define	FR_GOTOABSFRM			215
#define	FR_READLONGTOC			216
#define	FR_SETMODE			217
#define	FR_GETERROR			218
#define	FR_CLEARERROR			219
#define	FR_SPINUP			220
#define	FR_PLAB_STRTMIN			221
#define	FR_PLAB_STRTSEC			222
#define	FR_PLAB_STRTFRM			223
#define	FR_PLAB_STOPMIN			224
#define	FR_PLAB_STOPSEC			225
#define	FR_PLAB_STOPFRM			226
#define	FR_RELEASEAB			227
#define	FR_GETDISCSTAT			228
#define	FR_SETVOLUME			229
#define	FR_SESSIONINFO			230
#define	FR_SETDACMODE			231

#define	FR_SERVICE			232
#define	FR_SLEDGE			233
#define	FR_FOCUS			234
#define	FR_TURNTABLE			235
#define	FR_RADIAL			236

/* different command strings from servo processor */

#define	FR_FOUND			151
#define	FR_STOPPED			152
#define	FR_DISCSTATUS			153
#define	FR_ERRORVALUES			154
#define	FR_LENTITLELSB			155
#define	FR_LENTITLEMSB			156
#define	FR_TRAYMOVING			157
#define	FR_TRAYOPEN			158
#define	FR_TRAYCLOSED			159
#define	FR_ACTUALTITLE			160
#define	FR_ACTUALINDEX			161
#define	FR_ACTUALMINUTES		162
#define	FR_ACTUALSECONDS		163
#define	FR_ABSTIMEMINS			164
#define	FR_ABSTIMESECS			165
#define	FR_ABSTIMEFRMS			166
#define	FR_MODESTATUS			167
#define	FR_TOCVAL_MINTRK		168
#define	FR_TOCVAL_MAXTRK		169
#define	FR_TOCVAL_STARTMINS		170
#define	FR_TOCVAL_STARTSECS		171
#define	FR_TOCVAL_STARTFRMS		172
#define	FR_ABRELEASED			173
#define	FR_VOLUMELEVEL			174
#define	FR_MAXSESSIONS			175
#define	FR_LONGTOC_TRACK		176
#define	FR_LONGTOC_ATTR			177
#define	FR_LONGTOC_STARTMINS		178
#define	FR_LONGTOC_STARTSECS		179
#define	FR_LONGTOC_STARTFRMS		180
#define	FR_DACMODE			181
#define	FR_SERVOVERSION			182

/* errors in CD Module */

#define	FR_E_UNDEFINED			251

#define	FR_E_NOERROR			252
#define	FR_E_FOCUS			253
#define	FR_E_SUBCODE			254
#define	FR_E_READTOC			255
#define	FR_E_RADIAL			256
#define	FR_E_FATALSLEDGE		257
#define	FR_E_TURNTABLE			258
#define	FR_E_SEARCHTIMEOUT		259
#define	FR_E_SEARCHBINARY		260
#define	FR_E_SEARCHINDEX		261
#define	FR_E_SEARCHTIME			262
#define	FR_E_ILLEGALCOMMAND		263
#define	FR_E_ILLEGALVALUE		264
#define	FR_E_ILLEGALTIME		265
#define	FR_E_COMMUNICATION		266
#define	FR_E_TRAY			267
#define	FR_E_HFDETECTOR			268

/* -------------------------------------------------------------------------- */

int	st_load_resource( int );
int	st_load_freestrs( void );

int	st_error_message( int );
int	st_error_message_one( int, long );
int	st_error_message_two( int, long, long );
int	st_error_message_three( int, long, long, long );

unsigned char	*st_freestr( int );

/* -------------------------------------------------------------------------- */

#endif

/******************************************************************************/
/* End of ST_ERROR.H							      */
/******************************************************************************/
