/******************************************************************************/
/* ST_KEY.H								      */
/******************************************************************************/

#ifndef	__HEADER_ST_KEY
#define	__HEADER_ST_KEY		__HEADER_ST_KEY

/* -------------------------------------------------------------------------- */

/* If upper byte in the key in non-zero then the key is a control key */

#define	KbEXTND		0xFF00

#define	StSTAT_RSHIFT	0x01
#define	StSTAT_LSHIFT	0x02
#define	StSTAT_SHIFT	0x03
#define	StSTAT_CTRL	0x04
#define	StSTAT_ALT	0x08
#define	StSTAT_CAPS	0x10

/* -------------------------------------------------------------------------- */

/* Different codes for CONTROL KEY sequences */

#define		CTRL_2		0x0300

/* -----------------------------------------------------------------------------
#define		CTRL_A		0x1e01
#define		CTRL_B		0x3002
#define		CTRL_C		0x2e03
#define		CTRL_D		0x2004
#define		CTRL_E		0x1205
#define		CTRL_F		0x2106
#define		CTRL_G		0x2207
#define		CTRL_H		0x2308
#define		CTRL_I		0x1709
#define		CTRL_J		0x240a
#define		CTRL_K		0x250b
#define		CTRL_L		0x260c
#define		CTRL_M		0x320d
#define		CTRL_N		0x310e
#define		CTRL_O		0x180f
#define		CTRL_P		0x1910
#define		CTRL_Q		0x1011
#define		CTRL_R		0x1312
#define		CTRL_S		0x1f13
#define		CTRL_T		0x1414
#define		CTRL_U		0x1615
#define		CTRL_V		0x2f16
#define		CTRL_W		0x1117
#define		CTRL_X		0x2d18
#define		CTRL_Y		0x1519
#define		CTRL_Z		0x2c1a
#define		CTRL_OPENBRACE	0x1a1b
#define		CTRL_BACKSLASH	0x2b1c
#define		CTRL_CLOSBRACE	0x1b1d
#define		CTRL_SIX	0x071e
#define		CTRL_MINUS	0x0c1f
----------------------------------------------------------------------------- */

#define		CTRL_A		0xc001
#define		CTRL_B		0xc002
#define		CTRL_C		0xc003
#define		CTRL_D		0xc004
#define		CTRL_E		0xc005
#define		CTRL_F		0xc006
#define		CTRL_G		0xc007
#define		CTRL_H		0xc008
#define		CTRL_I		0xc009
#define		CTRL_J		0xc00a
#define		CTRL_K		0xc00b
#define		CTRL_L		0xc00c
#define		CTRL_M		0xc00d
#define		CTRL_N		0xc00e
#define		CTRL_O		0xc00f
#define		CTRL_P		0xc010
#define		CTRL_Q		0xc011
#define		CTRL_R		0xc012
#define		CTRL_S		0xc013
#define		CTRL_T		0xc014
#define		CTRL_U		0xc015
#define		CTRL_V		0xc016
#define		CTRL_W		0xc017
#define		CTRL_X		0xc018
#define		CTRL_Y		0xc019
#define		CTRL_Z		0xc01a

#define		CTRL_OPENBRACE	0xc01b
#define		CTRL_BACKSLASH	0xc01c
#define		CTRL_CLOSBRACE	0xc01d
#define		CTRL_SIX	0xc01e
#define		CTRL_MINUS	0xc01f

#define		CTRL_SHFT_A	0xd001
#define		CTRL_SHFT_B	0xd002
#define		CTRL_SHFT_C	0xd003
#define		CTRL_SHFT_D	0xd004
#define		CTRL_SHFT_E	0xd005
#define		CTRL_SHFT_F	0xd006
#define		CTRL_SHFT_G	0xd007
#define		CTRL_SHFT_H	0xd008
#define		CTRL_SHFT_I	0xd009
#define		CTRL_SHFT_J	0xd00a
#define		CTRL_SHFT_K	0xd00b
#define		CTRL_SHFT_L	0xd00c
#define		CTRL_SHFT_M	0xd00d
#define		CTRL_SHFT_N	0xd00e
#define		CTRL_SHFT_O	0xd00f
#define		CTRL_SHFT_P	0xd010
#define		CTRL_SHFT_Q	0xd011
#define		CTRL_SHFT_R	0xd012
#define		CTRL_SHFT_S	0xd013
#define		CTRL_SHFT_T	0xd014
#define		CTRL_SHFT_U	0xd015
#define		CTRL_SHFT_V	0xd016
#define		CTRL_SHFT_W	0xd017
#define		CTRL_SHFT_X	0xd018
#define		CTRL_SHFT_Y	0xd019
#define		CTRL_SHFT_Z	0xd01a

/* -------------------------------------------------------------------------- */

#define		KEY_ISO		0x6000
#define		KEY_UNDO	0x6100
#define		KEY_HELP	0x6200

#define		KEY_ENTER	0x720d

#define		KEY_UP		0x4800
#define		KEY_DOWN	0x5000
#define		KEY_LEFT	0x4b00
#define		KEY_RIGHT	0x4d00

#define		CTRL_LEFT	0x7300
#define		CTRL_RIGHT	0x7400

#define		SHFT_UP		0x4838
#define		SHFT_DOWN	0x5032
#define		SHFT_LEFT	0x4b34
#define		SHFT_RIGHT	0x4d36

#define		KEY_HOME	0x4700
#define		CTRL_HOME	0x7700
#define		SHFT_HOME	0x4737

#define		KEY_INS		0x5200
#define		SHFT_INS	0x5230

#define		KEY_DEL		0x537F
#define		CTRL_DEL	0x531F

#define		KEY_ESC		0x011B
#define		KEY_BS		0x0E08

#define		ALT_MINUS	0x8200
#define		ALT_EQUAL	0X8300

#define		KEY_CR		0x1C0d
#define		CTRL_CR		0x1C0a

#define		KEY_TAB		0x0F09
#define		SHFT_TAB	0x0F00

/* -------------------------------------------------------------------------- */

#define		KEY_F1		0x3B00
#define		KEY_F2		0x3C00
#define		KEY_F3		0x3D00
#define		KEY_F4		0x3E00
#define		KEY_F5		0x3F00
#define		KEY_F6		0x4000
#define		KEY_F7		0x4100
#define		KEY_F8		0x4200
#define		KEY_F9		0x4300
#define		KEY_F10		0x4400

#define		SHFT_F1		0x5400
#define		SHFT_F2		0x5500
#define		SHFT_F3		0x5600
#define		SHFT_F4		0x5700
#define		SHFT_F5		0x5800
#define		SHFT_F6		0x5900
#define		SHFT_F7		0x5A00
#define		SHFT_F8		0x5B00
#define		SHFT_F9		0x5C00
#define		SHFT_F10	0x5D00

/* -------------------------------------------------------------------------- */

#define		ALT_0		0x8100
#define		ALT_1		0x7800
#define		ALT_2		0x7900
#define		ALT_3		0x7a00
#define		ALT_4		0x7b00
#define		ALT_5		0x7c00
#define		ALT_6		0x7d00
#define		ALT_7		0x7e00
#define		ALT_8		0x7f00
#define		ALT_9		0x8000

#define		ALT_A		0x1e00
#define		ALT_B		0x3000
#define		ALT_C		0x2e00
#define		ALT_D		0x2000
#define		ALT_E		0x1200
#define		ALT_F		0x2100
#define		ALT_G		0x2200
#define		ALT_H		0x2300
#define		ALT_I		0x1700
#define		ALT_J		0x2400
#define		ALT_K		0x2500
#define		ALT_L		0x2600
#define		ALT_M		0x3200
#define		ALT_N		0x3100
#define		ALT_O		0x1800
#define		ALT_P		0x1900
#define		ALT_Q		0x1000
#define		ALT_R		0x1300
#define		ALT_S		0x1f00
#define		ALT_T		0x1400
#define		ALT_U		0x1600
#define		ALT_V		0x2f00
#define		ALT_W		0x1100
#define		ALT_X		0x2d00
#define		ALT_Y		0x1500
#define		ALT_Z		0x2c00

/* -------------------------------------------------------------------------- */

int	st_key_check( void );
unsigned int	st_key_process( unsigned int );

/* -------------------------------------------------------------------------- */

#endif

/******************************************************************************/
/* End of ST_KEY.H							      */
/******************************************************************************/
