/************************************************************************/
/* TITLE	: JOYPAD.H						*/
/* Function	: Joypad bit definitions				*/
/*									*/
/* Project #	: JAGUAR CD+G						*/
/* Programmer	: Pradip K Fatehpuria	11/10/93			*/
/*									*/
/* COPYRIGHT 1993 Atari Computer Corporation				*/
/* UNATHORIZED REPRODUCTION, ADAPTATION, DISTRIBUTION, PERFORMANCE OR	*/
/* DISPLAY OF THIS COMPUTER PROGRAM OR THE ASSOCIATED AUDIOVISUAL WORK	*/
/* IS STRICTLY PROHIBITED.						*/
/* ALL RIGHTS RESERVED.							*/
/************************************************************************/

/*======================================================================*/
/*	FORMAT = xxAPxxBx RLDU147* xxCxxxOx 2580369#			*/
/*======================================================================*/

#define	JOY_UP		0x00100000l	/* joypad directions */
#define	JOY_DOWN	0x00200000l
#define	JOY_LEFT	0x00400000l
#define	JOY_RIGHT	0x00800000l

#define	FIRE_A		0x20000000l	/* fire buttons */
#define	FIRE_B		0x02000000l
#define	FIRE_C		0x00002000l

#define	OPTION		0x00000200l	/* options button */
#define	PAUSE		0x10000000l	/* pause button */

#define	KEY_STAR	0x00010000l	/* numerical keypad */
#define	KEY_7		0x00020000l
#define	KEY_4		0x00040000l
#define	KEY_1		0x00080000l

#define	KEY_0		0x00000010l
#define	KEY_8		0x00000020l
#define	KEY_5		0x00000040l
#define	KEY_2		0x00000080l

#define	KEY_HASH	0x00000001l
#define	KEY_9		0x00000002l
#define	KEY_6		0x00000004l
#define	KEY_3		0x00000008l

/*======================================================================*/

#define	ANY_JOY		0x00F00000l	/* and joyedge with this - joypad */
					/* was pressed if result is not 0 */

#define	ANY_FIRE	0x32002200l	/* and joyedge with this - A,B C, */
					/* Option or Pausewas pressed if */
					/* result is not 0 */

#define	ANY_KEY		0x000F00FFl	/* and joyedge with this - */
					/* 23456789*0# was pressed if */
					/* result is not 0 */

/************************************************************************/
/*	END OF FILE							*/
/************************************************************************/

